#include <libusb-1.0/libusb.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "messages.h"

//read back the first 512 bytes of memory

typedef unsigned char uchar;
typedef unsigned short uword;


int main(int argc, char *argv[]) {
	if (argc < 2) {
		printf("Name of file?\n");
		return 0;
	}

	FILE *f = fopen(argv[1], "w");

	union {
		uchar c[8];
		uword w[4];
	}buf;

	if (libusb_init(NULL)) {
		printf("libusb init failed\n");
		libusb_exit(NULL);
		return 0;
	}

	libusb_device_handle *usbd = libusb_open_device_with_vid_pid(NULL, 0x16c0, 0x5dc);

	if (!usbd) {
		printf("Couldn't find (or open...) device\n");
		libusb_exit(NULL);
		return 0;
	}

	//this was used for something. Not any more, apparently.
	union {
		unsigned short w;
		unsigned char c[2];
	} address;
	
	for (address.w = 0; address.w < 0x200;address.w += 2) {
libusb_control_transfer(usbd, LIBUSB_RECIPIENT_DEVICE | LIBUSB_REQUEST_TYPE_VENDOR | LIBUSB_ENDPOINT_IN,
					MSG_READ, address.w, 0, buf.c, 8, 5000);
		fwrite(buf.c, 1, 2, f);
		printf("Read %x\n", address.w);
	}
	libusb_exit(NULL);

	return 0;
}

